%{?scl:%scl_package delve}
%{!?scl:%global pkg_name %{name}}

%global                 goproject   delve

Name:                   %{?scl_prefix}delve
Version:                1.7.2
Release:                1%{?dist}
Summary:                A debugger for the Go programming language

License:                MIT
URL:                    https://github.com/go-delve/delve
Source0:                https://github.com/go-delve/delve/archive/v%{version}.tar.gz#/%{goproject}-%{version}.tar.gz

ExcludeArch:            ppc64 ppc64le s390x aarch64 %{ix86} armv7hl

%if 0%{?rhel} <= 7 && ! 0%{?fedora}
%define gobuild(o:) scl enable go-toolset-1.17 -- go build -buildmode pie -compiler gc -tags="rpm_crashtraceback libtrust_openssl ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -compressdwarf=false -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '%__global_ldflags'" -a -v -x %{?**};
%else
%define gobuild(o:) go build -buildmode pie -compiler gc -tags="rpm_crashtraceback libtrust_openssl ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -compressdwarf=false -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '%__global_ldflags'" -a -v -x %{?**};
%endif

%if 0%{?rhel} <= 7 && ! 0%{?fedora}
%{?scl:BuildRequires: %{scl}-build %{scl}-runtime}
BuildRequires:          %{?scl_prefix}golang
%else
BuildRequires:          golang >= 1.17.0-0
%endif
BuildRequires:          git
BuildRequires:          lsof

Provides:               %{?scl_prefix}dlv = %{version}

%description
Delve is a debugger for the Go programming language. The goal of the project 
is to provide a simple, full featured debugging tool for Go. Delve should be 
easy to invoke and easy to use. Chances are if you're using a debugger, things 
aren't going your way. With that in mind, Delve should stay out of your way as 
much as possible.


%prep
%setup -q -n %{goproject}-%{version}

rm -rf go.mod
mv vendor %{_builddir}/src
mkdir -p "%{_builddir}/src/github.com/go-delve/"
cp -r %{_builddir}/%{goproject}-%{version} %{_builddir}/src/github.com/go-delve/%{goproject}
mkdir -p %{_builddir}/%{goproject}-%{version}/_build
mv %{_builddir}/src %{_builddir}/%{goproject}-%{version}/_build/src


%build
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
%gobuild -o bin/dlv github.com/go-delve/delve/cmd/dlv


%install
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
install -Dpm 0755 bin/dlv %{buildroot}%{_bindir}/dlv


%check
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
cd "_build/src/github.com/go-delve/%{goproject}"

# %if 0%{?rhel} <= 7 && ! 0%{?fedora}
# for d in $(scl enable go-toolset-1.16 -- go list ./... | grep -v cmd | grep -v scripts); do
#    scl enable go-toolset-1.16 -- go test ${d}
# done
# %else
# for d in $(go list ./... | grep -v cmd | grep -v scripts); do
#    go test ${d}
# done
# %endif


%files
%license LICENSE
%doc CONTRIBUTING.md CHANGELOG.md
%doc Documentation/*
%{_bindir}/dlv


%changelog
* Fri Oct 29 2021 Alejandro Sáez <asm@redhat.com> - 1.7.2-1
- Rebase to 1.7.2
- Related: rhbz#2014089

* Fri Mar 26 2021 Alejandro Sáez <asm@redhat.com> - 1.6.0-2
- Remove again the test suite temporarily. It is not working correctly.
- Related: rhbz#1883172

* Wed Mar 24 2021 Alejandro Sáez <asm@redhat.com> - 1.6.0-1
- Rebase to 1.6.0
- Removes golang-1.15.4 related patch
- Related: rhbz#1942116

* Tue Nov 24 2020 David Benoit <dbenoit@redhat.com> - 1.5.0-4
- Add golang-1.15.4 related patch
- Resolves: rhbz#1901209

* Mon Sep 28 2020 Alejandro Sáez <asm@redhat.com> - 1.5.0-3
- Remove the test suite temporarily. It is not working correctly.

* Fri Sep 25 2020 Alejandro Sáez <asm@redhat.com> - 1.5.0-2
- Add patch: Skip TestStepConcurrentDirect until we discover why it fails only on brew

* Fri Sep 18 2020 Alejandro Sáez <asm@redhat.com> - 1.5.0-1
- Rebase to 1.5.0

* Fri Jun 19 2020 Alejandro Sáez <asm@redhat.com> - 1.4.1-1
- Rebase to 1.4.1
- Related: rhbz#1847029
- Remove patch: 1781-pkg-terminal-Fix-exit-status.patch

* Fri Jan 31 2020 Alejandro Sáez <asm@redhat.com> - 1.3.2-1
- First package for RHEL 7
- Add patch: 1781-pkg-terminal-Fix-exit-status.patch
